SystemOrganization addCategory: 'OrbeonBPMWebBasic'!

SewafLateralListComposite subclass: #WAOrbeonProcessBrowser
	instanceVariableNames: 'seasideK mode categories transitionsHeight assignationComposite'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMWebBasic'!

WAOrbeonProcessBrowser subclass: #WAEmbeddedProcessBrowser
	instanceVariableNames: 'orbeonFrame orbeonIsOnPage isEditMode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMWebBasic'!

!WAEmbeddedProcessBrowser methodsFor: 'other' stamp: 'BrunoBB 06/02/2015 15:22'!
hasIFrame

	^orbeonFrame notNil! !

!WAEmbeddedProcessBrowser methodsFor: 'other' stamp: 'BrunoBB 06/02/2015 15:22'!
initialize

	super initialize.

	orbeonIsOnPage := false.
	isEditMode := false.! !

!WAEmbeddedProcessBrowser methodsFor: 'Accessing' stamp: 'BrunoBB 06/02/2015 15:22'!
isEditMode
	^isEditMode! !

!WAEmbeddedProcessBrowser methodsFor: 'Updating' stamp: 'BrunoBB 06/02/2015 15:22'!
isEditMode: newValue
	isEditMode := newValue! !

!WAEmbeddedProcessBrowser methodsFor: 'orbeon links' stamp: 'BrunoBB 12/11/2015 08:48'!
linkToOrbeonFormFor: aBpmArtifactInstance
	"The receiver gives the control to Orbeon Java application."
	| uuid |

	uuid  := OrbeonTempServiceRegistry default 
					createEntryToOrbeonFor: aBpmArtifactInstance 
					for: self session user.

	orbeonFrame := self getUrlFor: aBpmArtifactInstance with: uuid.! !

!WAEmbeddedProcessBrowser methodsFor: 'Accessing' stamp: 'BrunoBB 06/02/2015 15:22'!
orbeonFrame
	^orbeonFrame! !

!WAEmbeddedProcessBrowser methodsFor: 'Updating' stamp: 'BrunoBB 06/02/2015 15:22'!
orbeonFrame: newValue
	orbeonFrame := newValue! !

!WAEmbeddedProcessBrowser methodsFor: 'Accessing' stamp: 'BrunoBB 06/02/2015 15:22'!
orbeonIsOnPage
	^orbeonIsOnPage! !

!WAEmbeddedProcessBrowser methodsFor: 'Updating' stamp: 'BrunoBB 06/02/2015 15:22'!
orbeonIsOnPage: newValue
	orbeonIsOnPage := newValue! !

!WAEmbeddedProcessBrowser methodsFor: 'other' stamp: 'BrunoBB 07/01/2015 12:32'!
renderContentOn: html
	| widthClass |

	seasideK := self requestContext request at: '_k' ifAbsent: ['error'].

	self hasIFrame ifFalse: [^super renderContentOn: html].

	html div id: 'top-search-area'; with: [self renderSearchAreaOn: html.].

	showLateralList ifTrue: [
		html div id: 'lateral-assignment-list'; with: [self renderLateralListOn: html]].

	widthClass := showLateralList ifFalse: ['process-assignment-width100'] ifTrue: ['process-assignment-width80'].
	
	html div id: 'process-assignment'; class: widthClass;
		with: [self renderEmbeddedProcessAssignmentOn: html.
				self renderContentWithFrameOn: html].! !

!WAEmbeddedProcessBrowser methodsFor: 'other' stamp: 'BrunoBB 06/27/2015 14:59'!
renderContentWithFrameOn: html

	html div id: 'close-form-frame'; 
		with: [html anchor callback: [orbeonFrame := nil]; 
			with: [html image url: (SEWAFIconLibrary / #symboldeleteiconPng);
													title: ('Close Form' translateFor: self session user);
													altText: ('Close Form' translateFor: self session user)]].
	html div id: 'orbeon-form-frame'; 
		with: [html div id: 'orbeon-form'; with: [html iframe url: orbeonFrame]].! !

!WAEmbeddedProcessBrowser methodsFor: 'other' stamp: 'BrunoBB 06/27/2015 14:58'!
renderEmbeddedProcessAssignmentOn: html

	selectedLateralItem ifNil: [^self].

	html div id: 'process-assignment-description'; 
		with: [self renderItemDescriptionOn: html.].

	html horizontalRule.! !

WAOrbeonProcessBrowser subclass: #WALinkedProcessBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMWebBasic'!

!WALinkedProcessBrowser methodsFor: 'other' stamp: 'BrunoBB 12/11/2015 08:49'!
linkToOrbeonFormFor: aBpmArtifactInstance
	"The receiver gives the control to Orbeon Java application."
	| uuid |

	uuid  := OrbeonTempServiceRegistry default 
					createEntryToOrbeonFor: aBpmArtifactInstance 
					for: self session user.

	^self requestContext redirectTo: (self getUrlFor: aBpmArtifactInstance with: uuid).! !

!WAOrbeonProcessBrowser methodsFor: 'Accessing' stamp: 'BrunoBB 08/03/2016 05:32'!
assignationComposite
	^assignationComposite! !

!WAOrbeonProcessBrowser methodsFor: 'Updating' stamp: 'BrunoBB 08/03/2016 05:32'!
assignationComposite: newValue
	assignationComposite := newValue! !

!WAOrbeonProcessBrowser methodsFor: 'link to components' stamp: 'BrunoBB 08/03/2016 05:32'!
buildEditUrlFor: aBpmArtifactInstance with: anUUID
	"Answer a string Link to EDIT the Orbeon Form associated with the transition <aBpmArtifactInstance> using the security token <anUUID>"
	| formDefinition |

	formDefinition := aBpmArtifactInstance getDefinitionName.

	^self getOrbeonWebServerConfiguration orbeonIP,'/orbeon/fr/', aBpmArtifactInstance applicationName ,'/',formDefinition,'/edit/', aBpmArtifactInstance getOrbeonFormId,'?token=', anUUID,'&s=', self session key,'&k=', seasideK, '&oop=', aBpmArtifactInstance asOop printString, '&oop2=', selectedLateralItem asOop printString! !

!WAOrbeonProcessBrowser methodsFor: 'link to components' stamp: 'BrunoBB 08/03/2016 05:32'!
buildNewUrlFor: aBpmArtifactInstance with: anUUID
	"Answer a string Link to NEW Orbeon Form associated with the transition <aBpmArtifactInstance> using the security token <anUUID>"
	| formDefinition |

	formDefinition := aBpmArtifactInstance getDefinitionName.

	^self getOrbeonWebServerConfiguration orbeonIP, '/orbeon/fr/', aBpmArtifactInstance applicationName ,'/',formDefinition, '/new?token=', anUUID,'&s=', self session key,'&k=', seasideK, '&oop=', aBpmArtifactInstance asOop printString, '&oop2=', selectedLateralItem asOop printString! !

!WAOrbeonProcessBrowser methodsFor: 'link to components' stamp: 'BrunoBB 08/03/2016 05:32'!
buildPDFUrlFor: aBpmArtifactInstance with: anUUID
	"Answer a string Link to PDF the Orbeon Form associated with the transition <aBpmArtifactInstance> using the security token <anUUID>"
	| formDefinition |

	formDefinition := aBpmArtifactInstance getDefinitionName.

	^self getOrbeonWebServerConfiguration orbeonIP,'/orbeon/fr/', aBpmArtifactInstance applicationName ,'/',formDefinition,'/pdf/', aBpmArtifactInstance getOrbeonFormId,'?token=', anUUID,'&s=', self session key,'&k=', seasideK, '&oop=', aBpmArtifactInstance asOop printString, '&oop2=', selectedLateralItem asOop printString! !

!WAOrbeonProcessBrowser methodsFor: 'link to components' stamp: 'BrunoBB 08/03/2016 05:32'!
buildViewUrlFor: aBpmArtifactInstance with: anUUID
	"Answer a string Link to VIEW the Orbeon Form associated with the transition <aBpmArtifactInstance> using the security token <anUUID>"
	| formDefinition |

	formDefinition := aBpmArtifactInstance getDefinitionName.

	^self getOrbeonWebServerConfiguration orbeonIP,'/orbeon/fr/', aBpmArtifactInstance applicationName ,'/',formDefinition,'/view/', aBpmArtifactInstance getOrbeonFormId,'?token=', anUUID,'&s=', self session key,'&k=', seasideK, '&oop=', aBpmArtifactInstance asOop printString, '&oop2=', selectedLateralItem asOop printString! !

!WAOrbeonProcessBrowser methodsFor: 'Accessing' stamp: 'BrunoBB 08/03/2016 05:32'!
categories
	^categories! !

!WAOrbeonProcessBrowser methodsFor: 'Updating' stamp: 'BrunoBB 08/03/2016 05:32'!
categories: newValue
	categories := newValue! !

!WAOrbeonProcessBrowser methodsFor: 'other' stamp: 'BrunoBB 08/03/2016 11:03'!
clearAssignationCompostite

	assignationComposite := nil! !

!WAOrbeonProcessBrowser methodsFor: 'process' stamp: 'BrunoBB 08/03/2016 05:32'!
closeAndSendForm: aBpmArtifactInstance
	"After filling the form the user has clicked on close and send.
	The form can not be edited again."

	self session user finalizeAssignment: selectedLateralItem.

	self removeSelectionAndRefreshLateralCollection.! !

!WAOrbeonProcessBrowser methodsFor: 'process' stamp: 'BrunoBB 08/03/2016 15:18'!
closeSendAndSelectUsers: aBpmArtifactInstance
	| assignmentFinalization currentActivities newTasks |

"	self inform: 'Not Implemented Yet'."
	currentActivities := OrderedCollection withAll: (selectedLateralItem process currentActivities asArray remove: aBpmArtifactInstance; yourself).

	assignmentFinalization := self session user finalizeAssignment: selectedLateralItem.

	newTasks := selectedLateralItem process currentActivities asArray removeAll: currentActivities; yourself.

	newTasks ifEmpty: [^self].

	assignationComposite := WAAssignTasksToUsers parent: self on: newTasks.! !

!WAOrbeonProcessBrowser methodsFor: 'process' stamp: 'BrunoBB 08/03/2016 05:32'!
closeSendAndTakeNextForms: aBpmArtifactInstance
	"After filling the form the user has clicked on close and send.
	The form can not be edited again."

	self session user finalizeAssignment: selectedLateralItem takeNext: true.

	self removeSelectionAndRefreshLateralCollection.! !

!WAOrbeonProcessBrowser methodsFor: 'other' stamp: 'BrunoBB 08/03/2016 05:32'!
collapseIconFor: aBpmArtifactInstance

	((transitionsHeight includesKey: aBpmArtifactInstance) and: [(transitionsHeight at: aBpmArtifactInstance) = #collapsed])
	ifTrue: [^#circledown16Png].

	^#circleup16Png! !

!WAOrbeonProcessBrowser methodsFor: 'other' stamp: 'BrunoBB 08/03/2016 05:32'!
collapseTitleFor: aBpmArtifactInstance

	((transitionsHeight includesKey: aBpmArtifactInstance) and: [(transitionsHeight at: aBpmArtifactInstance) = #expanded]) 
	ifFalse: [^'Expand' translateFor: self session user].

	^'Collapse' translateFor: self session user! !

!WAOrbeonProcessBrowser methodsFor: 'link to components' stamp: 'BrunoBB 08/03/2016 05:32'!
createOrbeonLinkOn: html for: aBpmArtifactInstance

	"when a role has more than one active task with permission --> the edit and new icon is showed only with the properly assignment
 (aBpmArtifactInstance == selectedLateralItem task)"
	(((aBpmArtifactInstance == selectedLateralItem task) and: [aBpmArtifactInstance isDone not]) or: [aBpmArtifactInstance isDone])
	ifTrue: [
		html anchor callback: [self linkToOrbeonFormFor: aBpmArtifactInstance]; 
							with: [html image url: (SEWAFIconLibrary / (self iconFor: aBpmArtifactInstance));
														title: (self imageTitleFor: aBpmArtifactInstance);
														altText: (self imageTitleFor: aBpmArtifactInstance)].
	].
	(aBpmArtifactInstance hasForm and:[(aBpmArtifactInstance isGrantedUser: self session user)])
	ifTrue: [ html anchor callback: [self linkToOrbeonPdfFor: aBpmArtifactInstance];
							target: '_blank'; "open the PDF in a new tab or page"
							with: [html image url: (SEWAFIconLibrary / #pdf32Png);
														title: ('View PDF' translateFor: self session user);
														altText: ('View PDF' translateFor: self session user)].
	]
	"if the transition is done and has expected results --> we render an icon to show results summary"

"	(anOrbeonFormTransition isDone and:[anOrbeonFormTransition hasExpectedResult])
	ifTrue: [self renderExpectedResultIcon: html for: anOrbeonFormTransition]"! !

!WAOrbeonProcessBrowser methodsFor: 'link to components' stamp: 'BrunoBB 08/03/2016 05:32'!
createSeasideLinkOn: html for: aBpmArtifactInstance

	html anchor callback: [self linkToSeasideComponentFor: aBpmArtifactInstance]; 
						with: [html image url: (SEWAFIconLibrary / (self iconFor: aBpmArtifactInstance));
													title: (self imageTitleFor: aBpmArtifactInstance);
													altText: (self imageTitleFor: aBpmArtifactInstance)].! !

!WAOrbeonProcessBrowser methodsFor: 'other' stamp: 'BrunoBB 08/03/2016 05:32'!
displayModeFor: aBpmArtifactInstance

	^transitionsHeight at: aBpmArtifactInstance ifAbsent: [#expanded]! !

!WAOrbeonProcessBrowser methodsFor: 'export' stamp: 'BrunoBB 01/13/2017 12:57'!
downloadProcessMap
	| procInstance |

	procInstance := self selectedLateralItem process getTopProcess.

	procInstance definition hasSubProcesses
	ifTrue: [self downloadZipProcessMapOf: procInstance] 
	ifFalse: [self downloadProcessMapOf: procInstance].! !

!WAOrbeonProcessBrowser methodsFor: 'export' stamp: 'BrunoBB 01/13/2017 13:13'!
downloadProcessMapOf: aBpmProcessInstance

	self requestContext respond: [:response | 
        response document: ((aBpmProcessInstance getProcessMapStreamFor: self session user) contents asByteArray seasideMimeDocument) 
                                        mimeType: 'application/csv'; 
                                        fileName: (aBpmProcessInstance processName, '.xpdl'); 
                                        yourself].! !

!WAOrbeonProcessBrowser methodsFor: 'export' stamp: 'BrunoBB 01/13/2017 13:11'!
downloadZipProcessMapOf: aBpmProcessDefinition
	| fileName stream |

	stream := aBpmProcessDefinition getProcessMapStreamFor: self session user.
	fileName := stream gsfile name.

	self requestContext respond: [:response | 
        response document: ((stream contents asByteArray seasideMimeDocument) 
                                        mimeType: 'application/octet-stream'; 
                                        fileName: fileName; 
                                        yourself)].! !

!WAOrbeonProcessBrowser methodsFor: 'process' stamp: 'BrunoBB 09/13/2016 09:42'!
exportProcessInstanceAs
	| selectedOption stream converter |

	selectedOption := (self componentValueAt: 'exportProcess') "the jqdialog set this value"ifNil: [^self] ifNotNil: [:value | value].

	(selectedOption = #xpdl) ifTrue: [^self downloadProcessMap].

	(selectedOption = #svg) ifFalse: [^self].

	stream := PrintStream on: String new.
	converter := BizagiSvgConverter convert: (selectedLateralItem process generateProcessMapFor: self session user) prettyPrinted.

	stream nextPutAll: self xmlHeader, String lf;
		nextPutAll: (converter generateSVGFor: self session user assignment: selectedLateralItem).

	self requestContext respond: [:response | 
        response document: ((stream contents asByteArray seasideMimeDocument) 
                                        mimeType: 'image/svg+xml'; 
                                        fileName: (selectedLateralItem processName, '.svg'); 
                                        yourself)].! !

!WAOrbeonProcessBrowser methodsFor: 'categories' stamp: 'BrunoBB 08/03/2016 05:32'!
filterProcessDefinitionByCategory: aBpmProcessInstanceCategory

	searchApplied := true.
	searchResult := self getIterationCollection select: [:each | aBpmProcessInstanceCategory includes: each]! !

!WAOrbeonProcessBrowser methodsFor: 'process' stamp: 'brunobb 01/26/2018 18:16'!
freeSelectedAssignment

	selectedLateralItem isTaken 
	ifTrue: [self session user untake: selectedLateralItem.].

	lateralCollection remove: selectedLateralItem ifAbsent: [].
	searchResult remove: selectedLateralItem ifAbsent: [].

	selectedLateralItem := nil.

	self getCurrentCollection.! !

!WAOrbeonProcessBrowser methodsFor: 'search area' stamp: 'BrunoBB 12/03/2016 08:33'!
getAllAssignmentsFor: procName in: appName
	"Answer a collection of <OrbeonProcessAssignment> for the process named <procName> in application <appName>"
	| selectBlock |

	(appName isNil or: [appName isEmpty]) ifTrue: [^searchResult := self getIterationCollection].

	selectBlock := (procName = self viewAllText)
		ifTrue: [[:each | each applicationName = appName]]
		ifFalse: [[:each | each applicationName = appName and: [each processName = procName]]].

	searchResult := self getIterationCollection select: selectBlock! !

!WAOrbeonProcessBrowser methodsFor: 'other' stamp: 'BrunoBB 08/03/2016 05:32'!
getAllTasks

	selectedLateralItem ifNil: [^#()].

	self modeIsFinishedTasks ifFalse: [^selectedLateralItem getExecutedArtifacts, selectedLateralItem getRunningArtifacts].

	^OrderedCollection with: selectedLateralItem task! !

!WAOrbeonProcessBrowser methodsFor: 'lateral assignment' stamp: 'BrunoBB 08/03/2016 05:32'!
getCurrentCollection

	searchApplied ifFalse: [^lateralCollection].

	^searchResult! !

!WAOrbeonProcessBrowser methodsFor: 'search area' stamp: 'BrunoBB 08/03/2016 05:32'!
getFormDefinitionList
	"The receiver answer a collection with all form definitions of the selected process type at <searchValues> 'process-type'"
	| procDef |

	procDef := self getSelectedProcessDefinitionOrNil.

	procDef ifNil: [^#()].

	^self viewAllArray, procDef getTaskNames asSet asSortedCollection! !

!WAOrbeonProcessBrowser methodsFor: 'search area' stamp: 'BrunoBB 08/03/2016 05:32'!
getFormFieldList
	"The receiver answer a collection with all field names (removing layer mandatory fields -s,k,oop,uuid-) of the form type in <searchValues> 'form-type' "
	| selectedProcess selectedTask fieldList |

	selectedProcess := self getSelectedProcessDefinitionOrNil.
	selectedProcess ifNil: [^#()].
	selectedTask := self getSelectedTaskOrNil.
	selectedTask ifNil: [^#()].

	fieldList := #(''), (selectedProcess getFieldNamesOfTask: selectedTask name).

	^(fieldList remove: 'assignmentOop[s]' ifAbsent: []; 
			remove: 'k[s]' ifAbsent: []; 
			remove: 's[s]' ifAbsent: [];
			remove: 'oop[s]' ifAbsent: [];
			remove: 'uuid[s]' ifAbsent: [];
			yourself) asSortedCollection! !

!WAOrbeonProcessBrowser methodsFor: 'lateral assignment' stamp: 'BrunoBB 08/03/2016 05:32'!
getIconNameFormItem 

	^#pageprocess32Png! !

!WAOrbeonProcessBrowser methodsFor: 'search area' stamp: 'brunobb 02/01/2018 11:35'!
getIterationCollection
	"Get the iteration collection where the search process will iterate over to find a specific element"

	self modeIsFinishedTasks ifFalse: [^lateralCollection].

	^self session user getFinishedAssignments asArray! !

!WAOrbeonProcessBrowser methodsFor: 'search area' stamp: 'BrunoBB 08/03/2016 05:32'!
getSelectedApplicationOrNil

	^self getApplicationManagerClass getAnyApplicationNamed: (self searchValueAt: 'application' ifAbsent: '') ifNone: [nil]! !

!WAOrbeonProcessBrowser methodsFor: 'search area' stamp: 'BrunoBB 08/03/2016 05:32'!
getSelectedProcessDefinitionOrNil
	| definitions |

	definitions := BpmProcessDefinition 
							getAllProcessesNamed: (self searchValueAt: 'process-type' ifAbsent: ['']) 
							in: (self searchValueAt: 'application' ifAbsent: ['']).

	^definitions ifNotEmpty: [definitions last] ifEmpty: [nil]! !

!WAOrbeonProcessBrowser methodsFor: 'search area' stamp: 'BrunoBB 08/03/2016 05:32'!
getSelectedTaskOrNil
	"The receiver answer the current selected task (orbeon form definition or st model) or nil"

	^self getSelectedProcessDefinitionOrNil
		ifNil: [nil]
		ifNotNil: [:procDefinition | procDefinition getTaskNamed: (self searchValueAt: 'form-type' ifAbsent: ['']) ifNone: [nil]]! !

!WAOrbeonProcessBrowser methodsFor: 'lateral assignment' stamp: 'BrunoBB 08/03/2016 05:32'!
getTextForItem: aLateralListItem

	^aLateralListItem processName! !

!WAOrbeonProcessBrowser methodsFor: 'link to components' stamp: 'BrunoBB 08/03/2016 05:32'!
getUrlFor: aBpmArtifactInstance with: anUUID
	"Generate an url link to Java Orbeon application with context execution parameters (that are stored as hidden in the Java Orbeon Form) so the Java Application can return back to this web page with an updated domain model"
	| formDefinition |

	formDefinition := aBpmArtifactInstance getDefinitionName. "name of the form to link"
	^aBpmArtifactInstance hasForm "is a new or an edited form ?"
		ifFalse: [(aBpmArtifactInstance isGrantedUser: self session user) "has permissions ?"
					ifTrue: [self buildNewUrlFor: aBpmArtifactInstance with: anUUID]] "Orbeon NEW link"
		ifTrue: [(aBpmArtifactInstance isDone 
						or:[(aBpmArtifactInstance isGrantedUser: self session user) not 
						or: [(aBpmArtifactInstance innerTaskHasBeenFinalizedBy: self session user) and: [self modeIsFinishedTasks]]])
			ifFalse: [self buildEditUrlFor: aBpmArtifactInstance with: anUUID] "Orbeon EDIT link"
			ifTrue: [self buildViewUrlFor: aBpmArtifactInstance with: anUUID]] "Orbeon VIEW link"! !

!WAOrbeonProcessBrowser methodsFor: 'other' stamp: 'brunobb 07/27/2017 06:09'!
gitbookUrl

	^self modeIsFinishedTasks
	ifTrue: [self getGemStoneServerConfiguration baseUrlDocumentation, 'finished_processes.html']
	ifFalse: [self getGemStoneServerConfiguration baseUrlDocumentation, 'current_processes.html']! !

!WAOrbeonProcessBrowser methodsFor: 'link to components' stamp: 'BrunoBB 08/03/2016 05:32'!
iconFor: aBpmArtifactInstance

	aBpmArtifactInstance isCreated ifFalse: [^#pageprocess32Png].

	(aBpmArtifactInstance hasPerformers and: [aBpmArtifactInstance innerTaskHasBeenFinalizedBy: self session user])
	ifTrue: [^#processacceptPng].

	aBpmArtifactInstance isDone ifTrue: [^#processacceptPng].

	aBpmArtifactInstance isProcessing ifTrue: [^#documentediticonPng].
"	aBpmArtifactInstance isPaused ifTrue: [^#stopwatchpausePng].
	aBpmArtifactInstance isDelayed ifTrue: [^#clockPng].
	aBpmArtifactInstance isPending ifTrue: [^#aquastrippedfolderclockPng]."

	^#documentediticonPng! !

!WAOrbeonProcessBrowser methodsFor: 'link to components' stamp: 'BrunoBB 08/03/2016 05:32'!
imageTitleFor: aBpmArtifactInstance

	aBpmArtifactInstance isCreated ifFalse: [^'Create Task' translateFor: self session user].
	aBpmArtifactInstance isDone ifTrue:[^'Finished Task' translateFor: self session user].
	aBpmArtifactInstance isProcessing ifTrue: [^'Edit Task' translateFor: self session user].
"	aBpmArtifactInstance isPaused ifTrue: [^'Paused' translateFor: self session user].
	aBpmArtifactInstance isDelayed ifTrue: [^'Delayed' translateFor: self session user].
	aBpmArtifactInstance isPending ifTrue: [^'Pending' translateFor: self session user]."

	^'Undefined' translateFor: self session user! !

!WAOrbeonProcessBrowser methodsFor: 'other' stamp: 'BrunoBB 08/03/2016 05:32'!
initialize

	super initialize.

	searchAvailable := false.
	mode := #normal.
	categories := OrderedCollection new.
	transitionsHeight := Dictionary new.

	self setShowToElementNamed: 'search-area'. "the search-are is shown by default"

	batchedList := SewafLateralBatchedList parentComponent: self.
	batchedList batchSize: self session user lateralListPagingSize;
		navigationCssClass: 'batch-div-lateral-top'.! !

!WAOrbeonProcessBrowser methodsFor: 'other' stamp: 'BrunoBB 08/03/2016 05:32'!
isRangeSearch

	^(self searchValueAt: 'field-value-2' ifAbsent: [^false]) notNil! !

!WAOrbeonProcessBrowser methodsFor: 'link to components' stamp: 'BrunoBB 08/03/2016 05:32'!
linkToOrbeonFormFor: aBpmArtifactInstance
	"The receiver gives the control to Orbeon Java application."

	self subclassResponsibility! !

!WAOrbeonProcessBrowser methodsFor: 'link to components' stamp: 'BrunoBB 08/03/2016 05:32'!
linkToOrbeonPdfFor: aBpmArtifactInstance
	| uuid |

	uuid  := OrbeonTempServiceRegistry default 
					createEntryToOrbeonFor: aBpmArtifactInstance 
					for: self session user.

	^self requestContext redirectTo: (self buildPDFUrlFor: aBpmArtifactInstance with: uuid)! !

!WAOrbeonProcessBrowser methodsFor: 'link to components' stamp: 'BrunoBB 08/03/2016 05:32'!
linkToSeasideComponentFor: aBpmSeasideTaskInstance
  "The receiver gives the control to the component of task <aBpmSeasideTaskInstance>."
  | seasideModel |

  aBpmSeasideTaskInstance
    externalObject:
      (aBpmSeasideTaskInstance hasForm
        ifTrue: [aBpmSeasideTaskInstance externalObject]
        ifFalse: [aBpmSeasideTaskInstance getObjectModel]).

  seasideModel := aBpmSeasideTaskInstance externalObject.

  self show: (aBpmSeasideTaskInstance getComponentClass 
						newOn: seasideModel 
						task: aBpmSeasideTaskInstance 
						assignment: selectedLateralItem)! !

!WAOrbeonProcessBrowser methodsFor: 'Accessing' stamp: 'BrunoBB 08/03/2016 05:32'!
mode
	^mode! !

!WAOrbeonProcessBrowser methodsFor: 'Updating' stamp: 'BrunoBB 08/03/2016 05:32'!
mode: newValue
	"Set the mode of the receiver (#finished or #normal). 
	normal - is when lateral list is composed with current pending assignments.
	finished - is when lateral list is composed with finished assignments.
	If <mode> is different from <newValue> --> the sub menu has changed the <selectedLateralItem> must be reseted"

	(mode == newValue) ifFalse: [selectedLateralItem := nil].

	mode := newValue! !

!WAOrbeonProcessBrowser methodsFor: 'search area' stamp: 'BrunoBB 08/03/2016 05:32'!
modeIsFinishedTasks

	^mode = #finished! !

!WAOrbeonProcessBrowser methodsFor: 'categories' stamp: 'BrunoBB 08/03/2016 05:32'!
onProcessCategoryClicked: aProcessInstanceUserCategory

	self hasSelectedLateralItem ifFalse: [^self filterProcessDefinitionByCategory: aProcessInstanceUserCategory].

	(aProcessInstanceUserCategory includes: selectedLateralItem)
	ifTrue: [aProcessInstanceUserCategory remove: selectedLateralItem]
	ifFalse: [aProcessInstanceUserCategory add: selectedLateralItem]! !

!WAOrbeonProcessBrowser methodsFor: 'search area' stamp: 'BrunoBB 08/03/2016 05:32'!
registerProcessType: value

	self addSearchValue: value named: 'process-type'.
	self removeSearchValueNamed: 'form-type'.
	self removeSearchValueNamed: 'field-name'.
	self removeSearchValueNamed: 'field-value'.! !

!WAOrbeonProcessBrowser methodsFor: 'process' stamp: 'BrunoBB 08/03/2016 05:32'!
removeSelectionAndRefreshLateralCollection

	lateralCollection remove: selectedLateralItem ifAbsent: [].
	searchResult remove: selectedLateralItem ifAbsent: [].

	selectedLateralItem := nil.

	self getCurrentCollection.! !

!WAOrbeonProcessBrowser methodsFor: 'search area' stamp: 'BrunoBB 08/03/2016 05:32'!
renderApplicationComboOn: html

	html label 
		attributeAt: 'for' put: 'application';
		with: ('Application' translateFor: self session user).
	html select "Process Definition List"
		attributeAt: 'id' put: 'application';
		list: (#(''), (self session user getApplications collect: [:each | each applicationName])) asSet asSortedCollection;
		onChange: 'submit()';
		callback: [:value | self addSearchValue: value named: 'application'.];
		selected: (self searchValueAt: 'application' ifAbsent: ['']).! !

!WAOrbeonProcessBrowser methodsFor: 'search area' stamp: 'BrunoBB 08/03/2016 05:32'!
renderButtonWithoutFilters

	^((self hasSearchValueAt: 'field-name') and:[self hasSearchValueAt: 'form-type']) not! !

!WAOrbeonProcessBrowser methodsFor: 'categories' stamp: 'BrunoBB 08/03/2016 05:32'!
renderCategoriesListOn: html

	categories do: [:each | 
		html anchor callback: [self onProcessCategoryClicked: each]; 
			class: 'category-label';
			style: 'background-color:', each color;
			with: [html output: each name]].! !

!WAOrbeonProcessBrowser methodsFor: 'process' stamp: 'BrunoBB 08/03/2016 05:32'!
renderCloseAndSendFormOn: html for: aBpmArtifactInstance

	aBpmArtifactInstance isDone ifTrue: [^self].

	aBpmArtifactInstance isCreated ifFalse: [^self].
	(aBpmArtifactInstance isGrantedUser: self session user) ifFalse: [^self].

	"the task <aBpmArtifactInstance> is different from the current selected assignment"
	(aBpmArtifactInstance == selectedLateralItem task) ifFalse: [^self].

	(aBpmArtifactInstance canCloseAndSend or: [(aBpmArtifactInstance hasPerformers and: [aBpmArtifactInstance canCloseAndSendPerformer: self session user])])
		ifTrue: [self renderCloseAndSendIconOn: html for: aBpmArtifactInstance
		]! !

!WAOrbeonProcessBrowser methodsFor: 'process' stamp: 'brunobb 02/02/2018 13:52'!
renderCloseAndSendIconOn: html for: aBpmArtifactInstance
	| symbolIcon |

	symbolIcon := aBpmArtifactInstance isFinishedByPerformers ifFalse: [#tasksicon32Png] ifTrue: [#emailsendiconPng].

	html div class: 'float-right'; with: [
		html anchor callback: [self closeAndSendForm: aBpmArtifactInstance]; 
									with: [html image url: (SEWAFIconLibrary / symbolIcon); 
															title: ('Close & Send Form' translateFor: self session user);
															altText: ('Close & Send Form' translateFor: self session user)].

		aBpmArtifactInstance hasAutomaticTaskAssignation "if the assignation is automatic then it can NOT be forced by the web user (to him self or other users)"
		ifFalse: [ 
			html anchor callback: [self closeSendAndTakeNextForms: aBpmArtifactInstance]; 
										with: [html image url: (SEWAFIconLibrary / #applicationarrowright32Png); 
																title: ('Close, Send & Take Next Forms' translateFor: self session user);
																altText: ('Close, Send & Take Next Forms' translateFor: self session user)].

			html anchor callback: [self closeSendAndSelectUsers: aBpmArtifactInstance]; 
										with: [html image url: (SEWAFIconLibrary / #userarrowright32Png); 
																title: ('Close, Send & Select Users' translateFor: self session user);
																altText: ('Close, Send & Select Users' translateFor: self session user)].
		].
	].! !

!WAOrbeonProcessBrowser methodsFor: 'process' stamp: 'BrunoBB 08/03/2016 05:32'!
renderCompleteItemOn: html
	| heightClass |

	selectedLateralItem ifNil: [^self].

	html div id: 'item-complete-description'; class: 'lateral-right-component-description';
		with: [self renderItemDescriptionOn: html.].

	html horizontalRule.

	heightClass := mainPanel showMainMenu 
							ifFalse: ['item-customized-component-hide-top'] 
							ifTrue: ['item-customized-component-show-top'].

	html div id: 'item-customized-component'; class: heightClass; 
		with: [self renderItemComponentOn: html.].! !

!WAOrbeonProcessBrowser methodsFor: 'other' stamp: 'BrunoBB 08/03/2016 05:32'!
renderContentOn: html

	seasideK := self session requestContext request at: '_k' ifAbsent: ['error'].

	super renderContentOn: html.! !

!WAOrbeonProcessBrowser methodsFor: 'categories' stamp: 'BrunoBB 08/03/2016 05:32'!
renderCustomItemElementOn: html forItem: aBpmTaskAssignment

	(self session user getProcessInstanceCategoriesFor: aBpmTaskAssignment) do: [:each | 
		html div class: 'category-circle'; style: 'background-color: ', each color;
			with: [html output: each name first].
	].! !

!WAOrbeonProcessBrowser methodsFor: 'search area' stamp: 'BrunoBB 08/03/2016 05:32'!
renderFilterFields

	^(self hasSearchValueAt: 'form-type') 
		and: [(self hasSearchValueAt: 'process-type')  
		and:[(self hasSearchValueAt: 'field-name') 
		and:[self getSelectedProcessDefinitionOrNil notNil]]]! !

!WAOrbeonProcessBrowser methodsFor: 'search area' stamp: 'BrunoBB 01/09/2017 06:36'!
renderFilterValuesAndButtonOn: html
	| processName procDef formType fieldName fieldType |

	formType := self searchValueAt: 'form-type'.
	processName := self searchValueAt: 'process-type'.
	fieldName := self searchValueAt: 'field-name'.

	procDef := self getSelectedProcessDefinitionOrNil.

	fieldType := (procDef getTypeOfFieldNamed: fieldName) ifNil: [^self renderSearchSubmitButtonOn: html]  ifNotNil: [:type | type].

	((OrderedCollection with: String with: Boolean) includes: fieldType) ifTrue: [^html div class: 'top-search-filters-one'; with: [self renderOneFilterOn: html]].

	^html div class: 'top-search-filters-two'; with: [self renderTwoFitersOn: html].! !

!WAOrbeonProcessBrowser methodsFor: 'process' stamp: 'BrunoBB 02/08/2017 10:20'!
renderFormDataOn: html for: aBpmActivityInstance

	html div class: 'transition-data'; with: [
		html strong with: [html span with: ('User' translateFor: self session user)].
		html strong with: [html output "for: 'searchFields';" with: aBpmActivityInstance getUserName]].
	html div class: 'transition-data'; with: [
		html strong with: [html span with: ('State' translateFor: self session user)].
		html strong with: [html output "for: 'searchFields';" with: (aBpmActivityInstance printState translateFor: self session user)]].
"	html div class: 'transition-data'; with: [
		html strong with: [html span with: ('Previous Form' translateFor: self session user)].
		html strong with: [html output  with: (aBpmActivityInstance getDefinitionName translateFor: self session user)]]."
	html div class: 'transition-data'; with: [
		html strong with: [html span with: ('Form to Fill' translateFor: self session user)].
		html strong with: [html output "for: 'searchFields';" with: aBpmActivityInstance getDefinitionName]].
	html div class: 'transition-data'; with: [
		html strong with: [html span with: ('Creation Time' translateFor: self session user)].
		html strong with: [html output "for: 'searchFields';" with: aBpmActivityInstance creationTime]].

	(aBpmActivityInstance isDone not and: [aBpmActivityInstance hasExpectedExecutionTime]) ifTrue: [
		html div class: 'transition-data'; with: [
			html strong with: [html span with: ('Due Date' translateFor: self session user)].
			html strong with: [html output "for: 'searchFields';" 
										style: ('color: ', aBpmActivityInstance getWarningColor,';');
										with: aBpmActivityInstance printDueDate.]].
	].! !

!WAOrbeonProcessBrowser methodsFor: 'search area' stamp: 'BrunoBB 08/03/2016 05:32'!
renderFormDefinitionComboOn: html

	html label 
		attributeAt: 'for' put: 'formDefinitions';
		with: ('Form' translateFor: self session user).

	html select "Form Definition List" 
		attributeAt: 'id' put: 'formDefinitions';
		class: 'search-section-width-200';
		list: ((self hasSearchValueAt: 'process-type') 
				ifFalse: [#()] 
				ifTrue: [self getFormDefinitionList]);
		onChange: 'submit()';
		callback: [:value | self addSearchValue: value named: 'form-type'];
		selected: (self searchValueAt: 'form-type' ifAbsent: ['']).! !

!WAOrbeonProcessBrowser methodsFor: 'search area' stamp: 'BrunoBB 08/03/2016 05:32'!
renderFormFieldComboOn: html

	html label 
		attributeAt: 'for' put: 'formFields';
		with: ('Field' translateFor: self session user).

	html select "Field Definition List" 
		attributeAt: 'id' put: 'formFields';
		class: 'search-section-width-200';
		list: self getFormFieldList;
		onChange: 'submit()';
		callback: [:value | self addSearchValue: value named: 'field-name'];
		selected: (self searchValueAt: 'field-name' ifAbsent: ['']).! !

!WAOrbeonProcessBrowser methodsFor: 'process' stamp: 'BrunoBB 08/04/2016 08:40'!
renderItemComponentOn: html
	| heightClass |

	assignationComposite 
		ifNotNil: [html render: assignationComposite]
		ifNil: [
			self getAllTasks do:[:eachArtifact | | cssClass |
				cssClass := eachArtifact isTask 
					ifFalse: ['process-transition-gateway']
					ifTrue: [eachArtifact isDone
						ifTrue: ['process-transition-finished']
						ifFalse: ['process-transition-running']].

				heightClass := ((transitionsHeight at: eachArtifact ifAbsent: [#expanded]) = #expanded) 
										ifTrue: ['process-transition-expanded'] 
										ifFalse: ['process-transition-collapsed'].

				html div class: (cssClass, ' ', heightClass); with: [
					self renderTransitionDataOn: html for: eachArtifact].
			]. 
		].! !

!WAOrbeonProcessBrowser methodsFor: 'process' stamp: 'BrunoBB 08/03/2016 05:32'!
renderItemDescriptionAditionalDataOn: html

	html span with: [html strong: ('Assigned Date:' translateFor: self session user)].
	html output: selectedLateralItem printAssignmentDate.
	html span: [html strong: ('Current Forms:' translateFor: self session user)].
	html output: selectedLateralItem printProcessRunningArtifacts.
	html span: [html strong: ('Process Creator:' translateFor: self session user)].
	html output: selectedLateralItem printCreatorName.
	html span: [html strong: ('Can Unassign:' translateFor: self session user)]. 
	html output: (selectedLateralItem canUnassign printString translateFor: self session user).! !

!WAOrbeonProcessBrowser methodsFor: 'process' stamp: 'BrunoBB 08/03/2016 05:32'!
renderItemDescriptionSecondaryDataOn: html

	html span with: [html strong: ('Application:' translateFor: self session user)].
	html output: selectedLateralItem applicationName.
	html span with: [html strong: ('Process Id:' translateFor: self session user)].
	html output: selectedLateralItem processId.
	html span: [html strong: ('Version:' translateFor: self session user)]. 
	html output: selectedLateralItem version.
	html span: [html strong: ('Process State:' translateFor: self session user)].
	html output: (selectedLateralItem printProcessState translateFor: self session user).! !

!WAOrbeonProcessBrowser methodsFor: 'process' stamp: 'brunobb 01/26/2018 18:32'!
renderItemDescriptionTitleOn: html
	"The receiver render the summary of the object selected on the Lateral List "
	| jQueryId options |

	html output:  selectedLateralItem processName. "process name"
	selectedLateralItem isInCorruptedState 
	ifTrue: [html span with: [html strong: ('(Corrupted)' translateFor: self session user)]].

	(selectedLateralItem hasFinalized not and: [selectedLateralItem canUnassign])
	ifTrue: [
		html anchor 
			callback: [self freeSelectedAssignment]; 
			with: [html image url: (SEWAFIconLibrary / #gointo24Png); 
						title: ('Release Task' translateFor: self session user);
						altText: ('Release Task' translateFor: self session user)]].

	options := Array with: #('Export XPDL' #xpdl) with: #('View SVG' #svg).
	jQueryId := self renderJQuerySelectOptionDialogOn: html buttonsNames: options forActionNamed: 'exportProcess' actionMethod: #exportProcessInstanceAs arguments: #() extent: 420@120.

	html anchor 
		class: 'cursor-pointer';
		"callback: [self downloadProcessMap]; "
		onClick: (html jQuery id: jQueryId) dialog open;
		with: [html image url: (SEWAFIconLibrary / #documentflowchart24Png); 
					title: ('Process Map' translateFor: self session user);
					altText: ('Process Map' translateFor: self session user)].! !

!WAOrbeonProcessBrowser methodsFor: 'lateral assignment' stamp: 'BrunoBB 08/03/2016 05:32'!
renderLateralItemDetailsOn: html for: aLateralItem

	html strong with: [html output: aLateralItem processId].
	html strong with: [html output: aLateralItem printAssignmentDate].
	html strong with: [html output: aLateralItem printRunningArtifacts]! !

!WAOrbeonProcessBrowser methodsFor: 'search area' stamp: 'BrunoBB 08/03/2016 05:32'!
renderOneFilterOn: html

	self addSearchValue: nil named: 'field-value-2'. "clean the second value --> is not going to be used"

	html label 
		attributeAt: 'for' put: 'filterOne';
		class: 'search-section-float'; with: ('Field Value' translateFor: self session user).

	html textInput 
		attributeAt: 'id' put: 'filterOne';
		callback: [:value | self addSearchValue: value named: 'field-value'];
		with: (self searchValueAt: 'field-value' ifAbsent: ['']).

	self renderSearchSubmitButtonOn: html.! !

!WAOrbeonProcessBrowser methodsFor: 'process' stamp: 'brunobb 01/12/2018 13:13'!
renderOrbeonLinkIconOn: html for: aBpmTaskInstance

	aBpmTaskInstance processIsRunning ifFalse: [^self]. "if the process is paused or aborted no operation is possible with the task <aBpmTaskInstance>"

	"a granted user with edit permission"
	(aBpmTaskInstance isGrantedUser: self session user) 
	ifTrue: [^self createOrbeonLinkOn: html for: aBpmTaskInstance].
	"a user that has edit permission in other part of the process and does NOT have it this Transition, is granted to READ. 
	If the Form has not been created then there is NOTHING to view"
	((aBpmTaskInstance isGrantedUser: self session user) and: [aBpmTaskInstance hasForm]) 
	ifTrue: [^self createOrbeonLinkOn: html for: aBpmTaskInstance].

	"self createLinkForSeasideComponentOn: "! !

!WAOrbeonProcessBrowser methodsFor: 'search area' stamp: 'BrunoBB 08/03/2016 05:32'!
renderProcessTypeComboOn: html
	| definitionsNames |

	definitionsNames  := (BpmProcessDefinition getAllVersionsIn: (self searchValueAt: 'application' ifAbsent: [''])) collect: [:each | each processName].

	html label 
		attributeAt: 'for' put: 'processType';
		with: ('Process Type' translateFor: self session user).

	html select "Process Definition List"
		attributeAt: 'id' put: 'processType';
		list: self viewAllArray, definitionsNames
"(lateralCollection collect: [:each | each formProcessDefinition name]) asSet asSortedCollection";
		onChange: 'submit()';
		callback: [:value | self registerProcessType: value];
		selected: (self searchValueAt: 'process-type' ifAbsent: ['']).! !

!WAOrbeonProcessBrowser methodsFor: 'search area' stamp: 'BrunoBB 08/03/2016 05:32'!
renderSearchAreaOn: html

	self renderShowHideWindowIconOn: html. "show/hide search area"

	(self isEnabledToShowElementNamed: 'search-area') ifFalse: [^self].

	self searchPanelIsRegular 
	ifTrue: [self renderSearchRegularPanelOn: html]
	ifFalse: [self renderSearchCategoriesPanelOn: html].! !

!WAOrbeonProcessBrowser methodsFor: 'search area' stamp: 'BrunoBB 01/09/2017 06:14'!
renderSearchCategoriesPanelOn: html

	html form with: [ 
		html fieldSet with: [
			html legend class: 'top-search-legend'; with: ('Search Task' translateFor: self session user).
			self renderSwitchWindowOn: html.
			html div class: 'top-search-div'; with: [
				html label attributeAt: 'for' put: 'categotyLabel'; with: ('Category Name' translateFor: self session user).
				html textInput attributeAt: 'id' put: 'categotyLabel'; callback: [:value | self addSearchValue: value named: 'category-name'].
			].
			self renderCategoriesListOn: html.
			html div class: 'top-search-filters-one'; with: [
				html submitButton 
					style: 'margin-top: 25px';
					callback: [self searchMatchingCategories]; 
					with: ('Search' translateFor: self session user).].
		].
].! !

!WAOrbeonProcessBrowser methodsFor: 'search area' stamp: 'BrunoBB 12/03/2016 08:34'!
renderSearchRegularPanelOn: html

	html form with: [ 
		html fieldSet with: [
			html legend class: 'top-search-legend'; with: ('Search Task' translateFor: self session user).
			self renderSwitchWindowOn: html.
			html div class: 'top-search-div'; with: [
				html label attributeAt: 'for' put: 'processId'; with: ('Process Id' translateFor: self session user).
				html textInput attributeAt: 'id' put: 'processId'; 
						callback: [:value | self addSearchValue: value named: 'id'];
						value: (self searchValueAt: 'id')].
			html div class: 'top-search-div'; with: [self renderApplicationComboOn: html].
			html div class: 'top-search-div'; with: [self renderProcessTypeComboOn: html].
			html div class: 'top-search-div'; with: [self renderFormDefinitionComboOn: html].
			html div class: 'top-search-div'; with: [self renderFormFieldComboOn: html].
			self renderFilterFields 
			ifTrue: [self renderFilterValuesAndButtonOn: html]
			ifFalse: [self renderSearchSubmitButtonOn: html]
			"self renderButtonWithoutFilters ifTrue: [self renderSearchSubmitButtonOn: html]. "
		].
	]! !

!WAOrbeonProcessBrowser methodsFor: 'search area' stamp: 'BrunoBB 01/09/2017 06:15'!
renderSearchSubmitButtonOn: html
	| styleOption |

	styleOption := self renderFilterFields ifFalse: ['margin-top: 20px;'] ifTrue: [''].

	html div class: 'top-search-filters-one';
		style: styleOption;
		with: [
			html submitButton 
				class: '';
				callback: [self searchMatchingProcesses]; 
				with: ('Search' translateFor: self session user).
		]! !

!WAOrbeonProcessBrowser methodsFor: 'process' stamp: 'BrunoBB 08/03/2016 05:32'!
renderSeasideFormLinkIconOn: html for: aBpmSeasideTaskInstance

	"a granted user with edit permission"
	(aBpmSeasideTaskInstance isGrantedUser: self session user) 
	ifTrue: [^self createSeasideLinkOn: html for: aBpmSeasideTaskInstance].! !

!WAOrbeonProcessBrowser methodsFor: 'search area' stamp: 'BrunoBB 08/03/2016 05:32'!
renderSwitchWindowOn: html

	html div id: 'top-search-switch-icon'; with: [
		html anchor 
			callback: [searchPanelName := (searchPanelName = #search) ifTrue: [#categories] ifFalse: [#search]];
			with: [
				html div with: [
					html image url: (SEWAFIconLibrary / #ezswitchuser16Png); 
						altText: ('Switch Window' translateFor: self session user); 
						title: ('Switch Window' translateFor: self session user).
				].
		].
	].! !

!WAOrbeonProcessBrowser methodsFor: 'process' stamp: 'brunobb 01/12/2018 13:13'!
renderTransitionActionsOn: html for: aBpmArtifactInstance

	aBpmArtifactInstance isTask ifFalse: [^self].

	
	aBpmArtifactInstance processIsRunning "if the BpmProcess has been paused or aborted --> no link to the task"
	ifTrue: [
		aBpmArtifactInstance renderHtmlOn: html for: self. "double dispatching to render an Orbeon Link or a Seaside Component"

		(aBpmArtifactInstance isSubprocess not and: [aBpmArtifactInstance isDone not]) ifTrue: [self renderCloseAndSendFormOn: html for: aBpmArtifactInstance.].
	]! !

!WAOrbeonProcessBrowser methodsFor: 'process' stamp: 'BrunoBB 08/03/2016 05:32'!
renderTransitionDataOn: html for: aBpmArtifactInstance

	html anchor class: 'process-transition-icon-collapse';
		callback: [self switchOpenCloseTransition: aBpmArtifactInstance]; 
		with: [html image url: (SEWAFIconLibrary / (self collapseIconFor: aBpmArtifactInstance));
								title: (self collapseTitleFor: aBpmArtifactInstance);
								altText: (self collapseTitleFor: aBpmArtifactInstance)].

	html header with: [html strong: aBpmArtifactInstance printFormLargeNameForWebButton].
	html header with: [html strong: ('Task Data' translateFor: self session user)].

	((self displayModeFor: aBpmArtifactInstance) = #collapsed) ifTrue: [^self].

	aBpmArtifactInstance isTask 
	ifTrue: [^self renderTransitionFormDataOn: html for: aBpmArtifactInstance].

	aBpmArtifactInstance isSubprocessDefinition
	ifTrue: [^self renderTransitionSubProcessDataOn: html for: aBpmArtifactInstance].

	^self renderTransitionGatewayDataOn: html for: aBpmArtifactInstance! !

!WAOrbeonProcessBrowser methodsFor: 'process' stamp: 'BrunoBB 08/03/2016 05:32'!
renderTransitionFormDataOn: html for: aBpmArtifactInstance

	self renderFormDataOn: html for: aBpmArtifactInstance.

	self renderTransitionSummaryOn: html for: aBpmArtifactInstance.
	self renderTransitionActionsOn: html for: aBpmArtifactInstance.! !

!WAOrbeonProcessBrowser methodsFor: 'process' stamp: 'BrunoBB 08/03/2016 05:32'!
renderTransitionGatewayDataOn: html for: aBpmArtifactInstance

	aBpmArtifactInstance triggeredGateway ifNotNil: [:gateway |
		gateway outgoingTransitions do: [:transition |  
			html div class: 'transition-data'; with: [
				html strong with: [html span with: ('Condition' translateFor: self session user)].
				html strong with: [html output with: transition getStartConditionsString]].
			html div class: 'transition-data'; with: [
				html strong with: [html span with: ('Next Form' translateFor: self session user)].
				html strong with: [html output with: transition endFormName]].
		]
	].! !

!WAOrbeonProcessBrowser methodsFor: 'process' stamp: 'BrunoBB 08/03/2016 05:32'!
renderTransitionSubProcessDataOn: html for: aBpmArtifactInstance

	html div class: 'transition-data'; with: [
		html strong with: [html span with: ('User' translateFor: self session user)].
		html strong with: [html output "for: 'searchFields';" with: aBpmArtifactInstance getUserName]].
	html div class: 'transition-data'; with: [
		html strong with: [html span with: ('State' translateFor: self session user)].
		html strong with: [html output "for: 'searchFields';" with: (aBpmArtifactInstance printState translateFor: self session user)]].
	"html div class: 'transition-data'; with: [
		html strong with: [html span with: ('Previous Form' translateFor: self session user)].
		html strong with: [html output with: (anOrbeonFormTransition startFormName translateFor: self session user)]]."
	html div class: 'transition-data'; with: [
		html strong with: [html span with: ('Form to Fill' translateFor: self session user)].
		html strong with: [html output "for: 'searchFields';" with: aBpmArtifactInstance getDefinitionName]].
	html div class: 'transition-data'; with: [
		html strong with: [html span with: ('Initial Date' translateFor: self session user)].
		html strong with: [html output "for: 'searchFields';" with: aBpmArtifactInstance creationTime]].
	html div class: 'transition-data'; with: [
		html strong with: [html span with: ('Not implemented' translateFor: self session user)].
		html strong with: [html output "for: 'searchFields';" with: aBpmArtifactInstance creationTime]].

	self renderTransitionSummaryOn: html for: aBpmArtifactInstance.
	self renderTransitionActionsOn: html for: aBpmArtifactInstance.! !

!WAOrbeonProcessBrowser methodsFor: 'process' stamp: 'BrunoBB 08/03/2016 05:32'!
renderTransitionSummaryOn: html for: aBpmArtifactInstance

	html header with: [html strong: (aBpmArtifactInstance summaryTitle translateFor: self session user)].

	aBpmArtifactInstance getSummaryFieldsValues keysAndValuesDo: [:key :value | 
		html div class: 'transition-data'; with: [
			html strong with: [html span with: key].
			html strong with: [html output with: value]]].! !

!WAOrbeonProcessBrowser methodsFor: 'search area' stamp: 'BrunoBB 08/03/2016 05:32'!
renderTwoFitersOn: html

	html label 
		attributeAt: 'for' put: 'filterOne';
		class: 'search-section-float'; 
		with: ('Start Value' translateFor: self session user).
	html textInput 
		attributeAt: 'id' put: 'filterOne';
		callback: [:value | self addSearchValue: value named: 'field-value'];
		with: (self searchValueAt: 'field-value' ifAbsent: ['']).
	html label 
		attributeAt: 'for' put: 'filterTwo';
		class: 'search-section-float'; 
		with: ('End Value' translateFor: self session user).
	html textInput 
		attributeAt: 'id' put: 'filterTwo';
		callback: [:value | self addSearchValue: value named: 'field-value-2'];
		with: (self searchValueAt: 'field-value-2' ifAbsent: ['']).

	self renderSearchSubmitButtonOn: html.! !

!WAOrbeonProcessBrowser methodsFor: 'search area' stamp: 'BrunoBB 08/06/2016 12:49'!
searchByProcessId
	| id |

	id  := [Number fromString: (self searchValueAt: 'id' ifAbsent: ['0'])] on: Error do: [:err | 0].

	searchResult := self modeIsFinishedTasks 
								ifTrue: [self session user getAllFinishedTaskAssignmentsWithId: id] 
								ifFalse: [self session user getAllTaskAssignmentsWithId: id].

	selectedLateralItem := nil.
	"selectedTransition := nil."! !

!WAOrbeonProcessBrowser methodsFor: 'categories' stamp: 'BrunoBB 08/03/2016 05:32'!
searchMatchingCategories

	categories := (BpmProcessInstanceCategory getCategoriesFor: self session user) select: [:each | 
		(self searchValueAt: 'category-name' ifAbsent: ['']) match: each name].! !

!WAOrbeonProcessBrowser methodsFor: 'search area' stamp: 'BrunoBB 08/03/2016 05:32'!
searchMatchingProcesses
	"Answer a collection of <OrbeonProcessAssignment> that match the search criteria in receiver's web interface.
	The fast search performed against a field name and a field value in a Form (<formName>, <fieldName> and <fieldValue>). 
	If these values are not specified then answer a collection of <OrbeonProcessAssignment> for the process name <procName> in application <appName>"
	| appName procName formName fieldName fieldValue fieldValue2 |

	searchApplied := true.
	(self hasSearchValueAt: 'id') ifTrue: [^self searchByProcessId].

	selectedLateralItem := nil.

	appName := self searchValueAt: 'application' ifAbsent: [''].
	procName := self searchValueAt: 'process-type' ifAbsent: [''].
	formName := self searchValueAt: 'form-type' ifAbsent: ['']. (formName = self viewAllText) ifTrue: [formName := ''].
	fieldName  := self searchValueAt: 'field-name' ifAbsent: [''].
	fieldValue  := self searchValueAt: 'field-value' ifAbsent: [''].
	fieldValue2 := self searchValueAt: 'field-value-2' ifAbsent: [''].

	(formName isEmpty and: [fieldName isEmpty and: [fieldValue isEmpty]]) 
	ifTrue: [^self getAllAssignmentsFor: procName in: appName].

	searchResult := self isRangeSearch
		ifFalse: [BpmProcessDefinition getAssignmentsIn: appName processName: procName formName: formName fieldName: fieldName withValue: fieldValue]
		ifTrue: [BpmProcessDefinition getAssignmentsIn: appName processName: procName formName: formName fieldName: fieldName initialValue: fieldValue endValue: fieldValue2].

	searchResult := self modeIsFinishedTasks 
		ifFalse: [searchResult reject: [:each | each hasFinalized]] 
		ifTrue: [searchResult select: [:each | each hasFinalized]]! !

!WAOrbeonProcessBrowser methodsFor: 'Accessing' stamp: 'BrunoBB 08/03/2016 05:32'!
seasideK
	^seasideK! !

!WAOrbeonProcessBrowser methodsFor: 'Updating' stamp: 'BrunoBB 08/03/2016 05:32'!
seasideK: newValue
	seasideK := newValue! !

!WAOrbeonProcessBrowser methodsFor: 'other' stamp: 'BrunoBB 08/03/2016 05:32'!
selectedLateralItem: newValue
	| oldAssignment |

	oldAssignment := selectedLateralItem.
	selectedLateralItem := newValue.

	(newValue notNil and: [oldAssignment ~~ selectedLateralItem])
	ifTrue: [self setTransitionsHeight].! !

!WAOrbeonProcessBrowser methodsFor: 'other' stamp: 'BrunoBB 08/03/2016 05:32'!
setTransitionsHeight

	transitionsHeight := Dictionary new.

	self getAllTasks do: [:each | 
		self session user transitionDisplayModeIsExpanded
		ifTrue: [transitionsHeight at: each put: #expanded]
		ifFalse: [transitionsHeight at: each put: #collapsed]].

	^transitionsHeight! !

!WAOrbeonProcessBrowser methodsFor: 'other' stamp: 'BrunoBB 08/03/2016 05:32'!
switchOpenCloseTransition: aBpmArtifactInstance

	((transitionsHeight includesKey: aBpmArtifactInstance) and: [(transitionsHeight at: aBpmArtifactInstance) = #expanded])
	ifTrue: [transitionsHeight at: aBpmArtifactInstance put: #collapsed]
	ifFalse: [transitionsHeight at: aBpmArtifactInstance put: #expanded]! !

!WAOrbeonProcessBrowser methodsFor: 'Accessing' stamp: 'BrunoBB 08/03/2016 05:32'!
transitionsHeight
	^transitionsHeight! !

!WAOrbeonProcessBrowser methodsFor: 'Updating' stamp: 'BrunoBB 08/03/2016 05:32'!
transitionsHeight: newValue
	transitionsHeight := newValue! !

!WAOrbeonProcessBrowser methodsFor: 'other' stamp: 'BrunoBB 01/13/2017 13:24'!
xmlHeader

	^'<?xml version="1.0" encoding="utf-8"?>'! !

SEWAFWebObjectComposite subclass: #WAAssignTasksToUsers
	instanceVariableNames: 'tasksBatchedList usersBatchedList selectedTask assignationTable'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMWebBasic'!

!WAAssignTasksToUsers methodsFor: 'other' stamp: 'BrunoBB 08/03/2016 15:20'!
closeWindow

	assignationTable keysAndValuesDo: [:taskInstance :bpmUser | | assignment availableAssignments |
		availableAssignments := bpmUser getAllAvailableTaskAssignments.
		assignment := taskInstance getAssignment.
		(assignment notNil and: [availableAssignments includes: assignment]) ifTrue: [bpmUser take: assignment].
	].

	mainPanel clearAssignationCompostite.
	mainPanel removeSelectionAndRefreshLateralCollection.! !

!WAAssignTasksToUsers methodsFor: 'other' stamp: 'BrunoBB 08/07/2016 07:28'!
getColumnsForTasks

	^OrderedCollection new  
			add: ((SewafReportColumn 
						selector: #getDefinitionName 
						title: ('Task Name' translateFor: self session user)
						onClick: [:each | self onTaskClicked: each]) 
						beSearchable;
						sortBlock: [:a :b | a getDefinitionName <= b getDefinitionName]);
			add: (SewafReportColumn 
						selector: #state 
						title: ('Task State' translateFor: self session user));
			add: (SewafReportColumn 
						selector: #processId 
						title: ('Process Id' translateFor: self session user));
			yourself! !

!WAAssignTasksToUsers methodsFor: 'other' stamp: 'BrunoBB 08/03/2016 11:00'!
initialize

	super initialize.

	assignationTable := Dictionary new.
	tasksBatchedList := SewafBatchedList parentComponent: self.

	tasksBatchedList batchSize: self session user regularListPagingSize;
		navigationCssClass: 'batch-div-bottom';
		isBottomBatch: true.

	usersBatchedList := SewafBatchedList parentComponent: self.

	usersBatchedList batchSize: self session user regularListPagingSize;
		navigationCssClass: 'batch-div-bottom';
		isBottomBatch: true.! !

!WAAssignTasksToUsers methodsFor: 'other' stamp: 'BrunoBB 08/03/2016 11:00'!
initializeSewafTableForTasks
	| table |

	table := (SewafSelectTableReport parent: self)
		summary: 'Next Tasks';
		selectedColor: self session user userOptions getSelectTableSelectedColor;
		nonSelectedColor: self session user userOptions getSelectTableNonSelectedColor;
		columns: self getColumnsForTasks;
		rowColors: #(white white);
		rowPeriod: 1;
		selectedObject: selectedTask;
		yourself.

	
	^self addSewafTable: table named: 'Tasks'.! !

!WAAssignTasksToUsers methodsFor: 'other' stamp: 'BrunoBB 01/10/2017 03:44'!
initializeSewafTableForUsers
	"Table with all Users that are NOT present in the role <selectedObject> "
	| table column|

	column := SewafReportColumn selector: #username title: ('Username' translateFor: self session user).
	column beSortable; beSearchable; sortBlock: [:a :b | a username <= b username]. 
	table := (SewafBooleanSelectTable parent: self)
		summary: 'Users to Assign';
		backcolor: self session user userOptions getBooleanTableBackcolor;
		buttonLabel: ('Confirm' translateFor: self session user);
		booleanSelector: #isSelected:;
		callbackSelector: #selectUser:withValue:;
		columns: (OrderedCollection new add: column; 
						yourself);
		rowColors: #(white white);
		rowPeriod: 1;
		yourself.

	^self addSewafTable: table named: 'Users'.! !

!WAAssignTasksToUsers methodsFor: 'other' stamp: 'BrunoBB 08/03/2016 11:17'!
isSelected: aBpmUser

	^(assignationTable at: selectedTask ifAbsent: [^false]) == aBpmUser! !

!WAAssignTasksToUsers methodsFor: 'other' stamp: 'BrunoBB 08/03/2016 11:00'!
model: aCollectionOfTasks

	super model: aCollectionOfTasks.

	tasksBatchedList items: aCollectionOfTasks! !

!WAAssignTasksToUsers methodsFor: 'other' stamp: 'BrunoBB 08/07/2016 07:32'!
onTaskClicked: aBpmTaskInstance

	selectedTask := selectedTask 
			ifNil:[aBpmTaskInstance] 
			ifNotNil: [(selectedTask == aBpmTaskInstance) 
							ifTrue: [nil]  
							ifFalse: [aBpmTaskInstance]].

	usersBatchedList clearOrderMode.! !

!WAAssignTasksToUsers methodsFor: 'other' stamp: 'BrunoBB 08/04/2016 14:23'!
renderCloseWindowsButtonOn: html

	html form with: [
		html fieldSet with:[
			html submitButton class: 'border-radius10px';
				callback: [self closeWindow]; 
				with: ('Close' translateFor: self session user).
			html legend with: [html strong: ('Close Assignations' translateFor: self session user)].
		].
	].! !

!WAAssignTasksToUsers methodsFor: 'other' stamp: 'BrunoBB 08/07/2016 07:34'!
renderContentOn: html

	html div class: 'assignation-title'; with: [
		html text: 'Assign a User to each Task'].

	html div with: [
		html div class: 'left default-gray-table float-left '; with: [
			html render: (tasksBatchedList table: self sewafTableForTasks)].

		selectedTask ifNil: [^self].
		"if <orderMode> is true --> the user list has been sorted and it is already with the correct items"
		usersBatchedList hasOrderMode ifFalse: [usersBatchedList items: selectedTask getGrantedUsers].

		html div id: 'users-to-add';class: 'center default-gray-table float-left float-left'; with: [
			html render: (usersBatchedList table: self sewafTableForUsers)].

		html div id: 'assignation-close-form'; class: 'right'; with: [self renderCloseWindowsButtonOn: html].
	].! !

!WAAssignTasksToUsers methodsFor: 'other' stamp: 'BrunoBB 08/03/2016 11:00'!
searchBy: aSymbol

	tasksBatchedList 
		items: (tasksBatchedList items select: [:each |  | columnValue |
					columnValue := each perform: aSymbol.
					(self componentValueAt: 'searchValue') match: columnValue]).! !

!WAAssignTasksToUsers methodsFor: 'Accessing' stamp: 'BrunoBB 08/03/2016 11:00'!
selectedTask
	^selectedTask! !

!WAAssignTasksToUsers methodsFor: 'Updating' stamp: 'BrunoBB 08/03/2016 11:00'!
selectedTask: newValue
	selectedTask := newValue! !

!WAAssignTasksToUsers methodsFor: 'other' stamp: 'BrunoBB 08/04/2016 15:04'!
selectUser: aBpmUser withValue: aBoolean

	aBoolean 
	ifTrue: [assignationTable at: selectedTask put: aBpmUser.
				(self getTableNamed: 'Users' ifAbsent: [^self]) 
					information: ('User Assigned !!!!!!' translateFor: self session user)
					color: 'green'.]
	ifFalse: [((assignationTable includesKey: selectedTask) and: [(assignationTable at: selectedTask) == aBpmUser])
				ifTrue: [assignationTable removeKey: selectedTask ifAbsent: [].
							(self getTableNamed: 'Users' ifAbsent: [^self]) 
								information: ('User Unassigned !!!!!!' translateFor: self session user)
								color: 'red'.].].! !

!WAAssignTasksToUsers methodsFor: 'other' stamp: 'BrunoBB 08/03/2016 11:00'!
sewafTableForTasks
	| table |

	table := (self hasTableNamed: 'Tasks') 
		ifTrue: [self getTableNamed: 'Tasks' ifAbsent: []] 
		ifFalse: [self initializeSewafTableForTasks].

	table selectedObject:  selectedTask.

	^table! !

!WAAssignTasksToUsers methodsFor: 'other' stamp: 'BrunoBB 08/03/2016 11:00'!
sewafTableForUsers
	"Table with all Users that are NOT present in the role <selectedObject> "
	| table |

	table := (self hasTableNamed: 'Users') 
		ifTrue: [self getTableNamed: 'Users' ifAbsent: []] 
		ifFalse: [self initializeSewafTableForUsers].

	^table! !

!WAAssignTasksToUsers methodsFor: 'other' stamp: 'BrunoBB 08/07/2016 07:26'!
sortColumn: sortBlock orderMode: aSymbol

	usersBatchedList orderMode: aSymbol.
	usersBatchedList items: ( (aSymbol = #asc) 
		ifTrue: [(usersBatchedList items asSortedCollection: sortBlock) reverse] 
		ifFalse: [usersBatchedList items asSortedCollection: sortBlock]).! !

!WAAssignTasksToUsers methodsFor: 'Accessing' stamp: 'BrunoBB 08/03/2016 11:00'!
tasksBatchedList
	^tasksBatchedList! !

!WAAssignTasksToUsers methodsFor: 'Updating' stamp: 'BrunoBB 08/03/2016 11:00'!
tasksBatchedList: newValue
	tasksBatchedList := newValue! !

!WAAssignTasksToUsers methodsFor: 'Accessing' stamp: 'BrunoBB 08/03/2016 11:00'!
usersBatchedList
	^usersBatchedList! !

!WAAssignTasksToUsers methodsFor: 'Updating' stamp: 'BrunoBB 08/03/2016 11:00'!
usersBatchedList: newValue
	usersBatchedList := newValue! !

SEWAFWebObjectComposite subclass: #WABasicBpmChartComposite
	instanceVariableNames: 'canvas report'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMWebBasic'!

!WABasicBpmChartComposite methodsFor: 'other' stamp: 'BrunoBB 11/13/2016 13:22'!
analyzeQueryBlockIfFail: aOneArgumentBlock	
	| codeAnalyzer |

	codeAnalyzer := BpmProcessConditionCodeAnalyzer for: ((self searchValueAt: 'process-condition') ifNil: [^self] ifNotNil: [:value | value]).

	codeAnalyzer analyze.
	codeAnalyzer hasWarinings ifTrue: [^aOneArgumentBlock value: codeAnalyzer].

	^codeAnalyzer! !

!WABasicBpmChartComposite methodsFor: 'Accessing' stamp: 'BrunoBB 10/31/2016 10:47'!
canvas
	^canvas! !

!WABasicBpmChartComposite methodsFor: 'Updating' stamp: 'BrunoBB 10/31/2016 10:47'!
canvas: newValue
	canvas := newValue! !

!WABasicBpmChartComposite methodsFor: 'other' stamp: 'BrunoBB 11/08/2016 07:34'!
getAllArray

	^Array with: ('All' translateFor: self session user)! !

!WABasicBpmChartComposite methodsFor: 'other' stamp: 'BrunoBB 11/01/2016 08:02'!
getApplicationName

	^self searchValueAt: 'application' ifAbsent: [nil]! !

!WABasicBpmChartComposite methodsFor: 'other' stamp: 'BrunoBB 11/08/2016 13:37'!
getBpmUserName

	^self searchValueAt: 'bpm-user' ifAbsent: [nil]! !

!WABasicBpmChartComposite methodsFor: 'other' stamp: 'BrunoBB 11/12/2016 10:37'!
getDateFromSearchValueNamed: aString onError: anObject

	^[Date fromString: (self searchValueAt: aString)] 
		on: Error 
		do: [:err | (anObject class == Date) ifTrue: [self addSearchValue: anObject named: aString].
		anObject]! !

!WABasicBpmChartComposite methodsFor: 'query variables' stamp: 'BrunoBB 11/10/2016 03:49'!
getEndDate

	^self getDateFromSearchValueNamed: 'end' onError: (Date fromString: '12/31/2016')! !

!WABasicBpmChartComposite methodsFor: 'query variables' stamp: 'BrunoBB 11/10/2016 03:49'!
getFieldName

	^(self searchValueAt: 'field-name' ifAbsent: [^nil]), '[s]'  "FIX THIS - FIELD NAMES INCLUDES THE TYPE"! !

!WABasicBpmChartComposite methodsFor: 'query variables' stamp: 'BrunoBB 11/10/2016 03:49'!
getFieldName2

	^(self searchValueAt: 'field-name-2' ifAbsent: [^nil])! !

!WABasicBpmChartComposite methodsFor: 'query variables' stamp: 'BrunoBB 11/10/2016 03:49'!
getFormName

	^self searchValueAt: 'form-name' ifAbsent: [^nil]! !

!WABasicBpmChartComposite methodsFor: 'other' stamp: 'BrunoBB 11/17/2016 08:47'!
getFrontOfficeRoleClass

	^BpmFrontOfficeRole! !

!WABasicBpmChartComposite methodsFor: 'other' stamp: 'BrunoBB 11/17/2016 08:45'!
getProcessDefinitionClass

	^BpmProcessDefinition! !

!WABasicBpmChartComposite methodsFor: 'query variables' stamp: 'BrunoBB 11/10/2016 03:49'!
getProcessFieldList
	| fields selectedFormName |

	fields := OrderedCollection new.
	selectedFormName := self getFormName.

	self getSelectedProcessDefinitions do: [:procDef | 
		(procDef getTasks select: [:each | each name = selectedFormName]) do: [:eachTask | fields addAll: eachTask getComponentClass getFieldsNames]].

	^fields asSet asSortedCollection! !

!WABasicBpmChartComposite methodsFor: 'query variables' stamp: 'BrunoBB 11/21/2016 04:20'!
getProcessFormsList
	| forms |

	forms := OrderedCollection new.

	self getSelectedProcessDefinitions do: [:procDef | forms addAll: procDef getOrderedTasksNames].

	^forms asSet asSortedCollection! !

!WABasicBpmChartComposite methodsFor: 'other' stamp: 'BrunoBB 11/01/2016 09:46'!
getProcessName

	^self searchValueAt: 'process-name' ifAbsent: [nil]! !

!WABasicBpmChartComposite methodsFor: 'other' stamp: 'BrunoBB 11/08/2016 09:08'!
getRoleName

	^self searchValueAt: 'role' ifAbsent: [nil]! !

!WABasicBpmChartComposite methodsFor: 'query variables' stamp: 'BrunoBB 11/10/2016 03:49'!
getSelectedProcessDefinitions
	| versions |

	versions := BpmProcessDefinition getAllProcessesNamed: self getProcessName in: self getApplicationName.

	self isAllVersionSelected ifTrue: [^versions].

	^versions select: [:each | each version printString = self getVersion]! !

!WABasicBpmChartComposite methodsFor: 'query variables' stamp: 'BrunoBB 11/10/2016 03:49'!
getStartDate

	^self getDateFromSearchValueNamed: 'start' onError: (Date fromString: '01/01/2016')! !

!WABasicBpmChartComposite methodsFor: 'query variables' stamp: 'BrunoBB 11/10/2016 03:49'!
getVersion

	^(self searchValueAt: 'version' ifAbsent: [^nil]) ifNotNil: [:value | (value = 'All') ifTrue: [nil] ifFalse: [value]]! !

!WABasicBpmChartComposite methodsFor: 'other' stamp: 'BrunoBB 11/01/2016 09:42'!
initialize

	super initialize.

	self setShowToElementNamed: 'search-area'. "the search-are is shown by default"! !

!WABasicBpmChartComposite methodsFor: 'query variables' stamp: 'BrunoBB 11/19/2016 07:19'!
isAllRolesSelected

	^(self searchValueAt: 'role' ifAbsent: [^false]) = ('All' translateFor: self session user)! !

!WABasicBpmChartComposite methodsFor: 'query variables' stamp: 'BrunoBB 11/19/2016 07:19'!
isAllVersionSelected

	^(self searchValueAt: 'version' ifAbsent: [^false]) = ('All' translateFor: self session user)! !

!WABasicBpmChartComposite methodsFor: 'query variables' stamp: 'BrunoBB 11/12/2016 08:26'!
isAverageTaskTimeDistribution

	^(self searchValueAt: 'distribution' ifAbsent: [nil]) = ('Average Time per Task' translateFor: self session user)! !

!WABasicBpmChartComposite methodsFor: 'query variables' stamp: 'BrunoBB 11/12/2016 08:26'!
isBarChart

	^(self searchValueAt: 'chart-type' ifAbsent: [nil]) = ('Bar Chart' translateFor: self session user)! !

!WABasicBpmChartComposite methodsFor: 'query variables' stamp: 'BrunoBB 11/12/2016 08:26'!
isCreationDayDistribution

	^(self searchValueAt: 'distribution' ifAbsent: [nil]) = ('Creation Day' translateFor: self session user)! !

!WABasicBpmChartComposite methodsFor: 'query variables' stamp: 'BrunoBB 11/12/2016 08:26'!
isDonutChart

	^(self searchValueAt: 'chart-type' ifAbsent: [nil]) = ('Donut Chart' translateFor: self session user)! !

!WABasicBpmChartComposite methodsFor: 'query variables' stamp: 'BrunoBB 11/12/2016 08:26'!
isDoubleBarChart

	^(self searchValueAt: 'chart-type' ifAbsent: [nil]) = ('Double Bar Chart' translateFor: self session user)! !

!WABasicBpmChartComposite methodsFor: 'query variables' stamp: 'BrunoBB 11/06/2016 07:56'!
isDoubleChart

	^self isDoubleBarChart or: [self isDoubleDonutChart]! !

!WABasicBpmChartComposite methodsFor: 'query variables' stamp: 'BrunoBB 11/12/2016 08:26'!
isDoubleDonutChart

	^(self searchValueAt: 'chart-type' ifAbsent: [nil]) = ('Double Donut Chart' translateFor: self session user)! !

!WABasicBpmChartComposite methodsFor: 'query variables' stamp: 'BrunoBB 11/12/2016 08:27'!
isFieldValueDistribution

	^(self searchValueAt: 'distribution' ifAbsent: [nil]) = ('Field Value' translateFor: self session user)! !

!WABasicBpmChartComposite methodsFor: 'query variables' stamp: 'BrunoBB 11/12/2016 08:27'!
isNumberOfTasksDistributionSelection

	^(self searchValueAt: 'distribution' ifAbsent: [nil]) = ('Number of Tasks' translateFor: self session user)! !

!WABasicBpmChartComposite methodsFor: 'query variables' stamp: 'BrunoBB 11/12/2016 06:39'!
isNumberOfUsersDistribution

	^(self searchValueAt: 'distribution' ifAbsent: [nil]) = ('Number of Users' translateFor: self session user)! !

!WABasicBpmChartComposite methodsFor: 'query variables' stamp: 'BrunoBB 11/12/2016 08:29'!
isProcessDefinitionDistribution

	^(self searchValueAt: 'distribution' ifAbsent: [nil]) = ('Process Definition' translateFor: self session user)! !

!WABasicBpmChartComposite methodsFor: 'query variables' stamp: 'BrunoBB 11/12/2016 08:29'!
isProcessDefinitionDistributionAndBarChart

	^self isProcessDefinitionDistribution and:[self isBarChart]! !

!WABasicBpmChartComposite methodsFor: 'query variables' stamp: 'BrunoBB 11/12/2016 08:29'!
isProcessDefinitionDistributionAndDonutChart

	^self isProcessDefinitionDistribution and:[self isDonutChart]! !

!WABasicBpmChartComposite methodsFor: 'query variables' stamp: 'BrunoBB 11/12/2016 08:29'!
isProcessesAverageTimeDistribution

	^(self searchValueAt: 'distribution' ifAbsent: [nil]) = ('Processes Average Time' translateFor: self session user)! !

!WABasicBpmChartComposite methodsFor: 'query variables' stamp: 'BrunoBB 11/12/2016 08:29'!
isProcessInstanceDistribution

	^(self searchValueAt: 'distribution' ifAbsent: [nil]) = ('Process Instances' translateFor: self session user)! !

!WABasicBpmChartComposite methodsFor: 'query variables' stamp: 'BrunoBB 11/12/2016 08:30'!
isProcessInstanceDistributionAndBarChart

	^self isProcessInstanceDistribution and:[self isBarChart]! !

!WABasicBpmChartComposite methodsFor: 'query variables' stamp: 'BrunoBB 11/12/2016 08:30'!
isProcessInstanceDistributionAndDonutChart

	^self isProcessInstanceDistribution and:[self isDonutChart]! !

!WABasicBpmChartComposite methodsFor: 'query variables' stamp: 'BrunoBB 11/12/2016 08:30'!
isTasksAverageTimeDistribution

	^(self searchValueAt: 'distribution' ifAbsent: [nil]) = ('Tasks Average Time' translateFor: self session user)! !

!WABasicBpmChartComposite methodsFor: 'query variables' stamp: 'BrunoBB 11/12/2016 08:30'!
isUnassignedTasksDistribution

	^(self searchValueAt: 'distribution' ifAbsent: [nil]) = ('Unassigned Tasks' translateFor: self session user)! !

!WABasicBpmChartComposite methodsFor: 'query variables' stamp: 'BrunoBB 11/12/2016 08:30'!
isUserNumberOfTasksDistribution

	^(self searchValueAt: 'distribution' ifAbsent: [nil]) = ('Number of Tasks' translateFor: self session user)! !

!WABasicBpmChartComposite methodsFor: 'query variables' stamp: 'BrunoBB 11/12/2016 08:30'!
isUserPossibleTasksDistribution

	^(self searchValueAt: 'distribution' ifAbsent: [nil]) = ('Possible Tasks' translateFor: self session user)! !

!WABasicBpmChartComposite methodsFor: 'query variables' stamp: 'BrunoBB 11/13/2016 13:38'!
queryBlock

	^(self searchValueAt: 'process-condition') 
		ifNil: [[:each | true]] 
		ifNotNil: [:blockString | [blockString evaluate isBlock 
											ifTrue: [blockString evaluate] 
											ifFalse: [[:each | false]] ] on: Error do: [:ex | [:each | false]]]! !

!WABasicBpmChartComposite methodsFor: 'other' stamp: 'BrunoBB 11/13/2016 12:58'!
queryBlockFailedWith: aBpmCodeAnalyzer

	self addSearchValue: ' " ', aBpmCodeAnalyzer printCodeWarnings, ' " ', String lf, (self searchValueAt: 'process-condition')
			named: 'process-condition'! !

!WABasicBpmChartComposite methodsFor: 'render' stamp: 'BrunoBB 11/19/2016 06:10'!
renderActiveDistributionComboOn: html withDistribution: distributionNames

	^self renderGenericActiveComboOn: html withList: distributionNames forVariable: 'distribution' label: ('Distribution' translateFor: self session user)! !

!WABasicBpmChartComposite methodsFor: 'render' stamp: 'BrunoBB 11/01/2016 09:36'!
renderApplicationComboOn: html

	self renderApplicationComboOn: html withApplications: (self session user getBackofficeApplications collect: [:each | each applicationName]) asSortedCollection.! !

!WABasicBpmChartComposite methodsFor: 'render' stamp: 'BrunoBB 11/19/2016 06:10'!
renderApplicationComboOn: html withApplications: applicationNames

	^self renderGenericActiveComboOn: html withList: (#(''), applicationNames) forVariable: 'application' label: ('Application' translateFor: self session user)! !

!WABasicBpmChartComposite methodsFor: 'render' stamp: 'BrunoBB 11/19/2016 06:10'!
renderChartTypeComboOn: html withCharts: chartsNames
	| chartTypes |

	chartTypes := chartsNames collect: [:each | each translateFor: self session user]. 

	^self renderGenericComboOn: html withList: chartTypes forVariable: 'chart-type' label: ('Chart Type' translateFor: self session user)! !

!WABasicBpmChartComposite methodsFor: 'render' stamp: 'BrunoBB 11/01/2016 09:19'!
renderContentOn: html

	html div id: 'top-search-area'; class: 'top-search-area-box-shadow';
		with: [self renderSearchAreaOn: html].

	canvas notNil ifTrue: [self renderGraphOn: html]! !

!WABasicBpmChartComposite methodsFor: 'render' stamp: 'BrunoBB 11/19/2016 06:10'!
renderDistributionComboOn: html withDistribution: distributionNames
	| distributionTypes |

	distributionTypes := distributionNames collect: [:each | each translateFor: self session user]. 

	^self renderGenericComboOn: html withList: distributionTypes forVariable: 'distribution' label: ('Distribution' translateFor: self session user)! !

!WABasicBpmChartComposite methodsFor: 'render' stamp: 'BrunoBB 01/09/2017 06:13'!
renderGraphOn: html
	| jQueryId |

	jQueryId := self renderJQueryInformationDialogOn: html 
							title: 'Information' 
							information: ('Chart Saved !!' translateFor: self session user) 
							buttonLabel: ('Close' translateFor: self session user) 
							actionMethod: #saveChart.
	html div 
		class: 'display-inline-flex margin-left-5px width-100per height100per';
		with: [ 
			html div 
				class: 'margin-top-5px';
				with: [
					html anchor 
						class: 'cursor-pointer';
						onClick: (html jQuery id: jQueryId) dialog open;
						with: [html image url: (SEWAFIconLibrary / #actionsdocumentsaveas24Png); 
										altText: ('Save Chart' translateFor: self session user); 
										title: ('Save Chart' translateFor: self session user)].
				].

			html div id: 'orbeon-graph'; class: 'overflow-scroll height100per width-100per'; with: [html html: canvas contents].
		].! !

!WABasicBpmChartComposite methodsFor: 'render' stamp: 'BrunoBB 11/10/2016 03:14'!
renderQueryConditionOn: html

	html div class: 'top-search-div'; with: [
		html label attributeAt: 'for' put: 'process-condition'; with: ('Condition Block' translateFor: self session user).

		html textArea 
			class: 'process-query-condition';
			attributeAt: 'id' put: 'process-condition'; 
			callback: [:value | self addSearchValue: value named: 'process-condition']; 
			with: (self searchValueAt: 'process-condition').
	].! !

!WABasicBpmChartComposite methodsFor: 'render' stamp: 'BrunoBB 11/08/2016 07:47'!
renderRolesComboOn: html 
 
	^self renderRolesComboOn: html withRoles: ((BpmFrontOfficeRole getRolsInAppName: self getApplicationName) collect: [:each | each name]) asSortedCollection! !

!WABasicBpmChartComposite methodsFor: 'render' stamp: 'BrunoBB 11/19/2016 06:11'!
renderRolesComboOn: html withRoles: roleNames

	^self renderGenericActiveComboOn: html withList: (self getAllArray, roleNames) forVariable: 'role' label: ('Role' translateFor: self session user)! !

!WABasicBpmChartComposite methodsFor: 'render' stamp: 'BrunoBB 11/08/2016 07:17'!
renderSearchAreaOn: html

	self renderShowHideWindowIconOn: html. "show/hide search area"

	(self isEnabledToShowElementNamed: 'search-area') ifFalse: [^self].! !

!WABasicBpmChartComposite methodsFor: 'render' stamp: 'BrunoBB 01/09/2017 06:15'!
renderShowChartButtonOn: html

	html div class: 'top-search-filters-one'; 
		class: 'width-100px margin-top-20px';
		with: [
			html submitButton 
				callback: [self showChart]; 
				with: ('Show Chart' translateFor: self session user).
		].! !

!WABasicBpmChartComposite methodsFor: 'render' stamp: 'BrunoBB 11/05/2016 11:51'!
renderStartEndDatesOn: html

	html div class: 'top-search-div'; with: [
		html label attributeAt: 'for' put: 'start'; with: ('Start' translateFor: self session user).
		html textInput 
				attributeAt: 'id' put: 'start'; 
				callback: [:value | self addSearchValue: value named: 'start']; 
				with: (self searchValueAt: 'start').
	].

	html div class: 'top-search-div'; with: [
		html label attributeAt: 'for' put: 'end'; with: ('End' translateFor: self session user).
		html textInput 
				attributeAt: 'id' put: 'end'; 
				callback: [:value | self addSearchValue: value named: 'end']; 
				with: (self searchValueAt: 'end').
	].! !

!WABasicBpmChartComposite methodsFor: 'Accessing' stamp: 'BrunoBB 11/18/2016 07:07'!
report
	^report! !

!WABasicBpmChartComposite methodsFor: 'Updating' stamp: 'BrunoBB 11/18/2016 07:07'!
report: newValue
	report := newValue! !

!WABasicBpmChartComposite methodsFor: 'other' stamp: 'BrunoBB 11/19/2016 07:34'!
saveChart

	report addToCache! !

!WABasicBpmChartComposite methodsFor: 'other' stamp: 'BrunoBB 11/01/2016 07:59'!
showChart

	^self subclassResponsibility! !

!WABasicBpmChartComposite methodsFor: 'other' stamp: 'BrunoBB 10/31/2016 10:29'!
svgCanvasClass

	^JASVGIGraphCanvas! !

SEWAFWebObjectComposite subclass: #WAChangeUserPasswordComposite
	instanceVariableNames: 'informationComponent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMWebBasic'!

!WAChangeUserPasswordComposite methodsFor: 'other' stamp: 'BrunoBB 12/03/2016 05:53'!
changePassword

	informationComponent ifNil: [informationComponent := SewafInformComponent parent: self].
	(self session user password = (searchValues at: 'current-pwd')) 
	ifFalse: [^informationComponent information: ('Invalid Current Password !!!!!!' translateFor: self session user) color: 'red'].

	((searchValues at: 'repeat-new-pwd') = (searchValues at: 'new-pwd')) 
	ifFalse: [^informationComponent information:  ('New Password and Repeat New Password must be equal !!!!!!' translateFor: self session user) color: 'red'].

	self session user password: (searchValues at: 'new-pwd').

	^informationComponent information: ('Password has been changed !!!!!!' translateFor: self session user) color: 'green'! !

!WAChangeUserPasswordComposite methodsFor: 'other' stamp: 'brunobb 07/27/2017 06:08'!
gitbookUrl

	^self getGemStoneServerConfiguration baseUrlDocumentation, 'change_password.html'! !

!WAChangeUserPasswordComposite methodsFor: 'Accessing' stamp: 'BrunoBB 12/03/2016 05:53'!
informationComponent
	^informationComponent! !

!WAChangeUserPasswordComposite methodsFor: 'Updating' stamp: 'BrunoBB 12/03/2016 05:53'!
informationComponent: newValue
	informationComponent := newValue! !

!WAChangeUserPasswordComposite methodsFor: 'other' stamp: 'BrunoBB 12/03/2016 05:53'!
renderChangePasswordOn: html

	html div id: 'change-password'; class: 'centered-unique-form';
		with: [html form with: [
					html fieldSet with:[
						html legend with: [html strong: ('Change Password' translateFor: self session user)].
						html label attributeAt: 'for' put: 'currentPassword'; with: ('Current Password' translateFor: self session user).
						html textInput attributeAt: 'id' put: 'currentPassword'; callback: [:value | searchValues at: 'current-pwd' put: value].
						html label attributeAt: 'for' put: 'newPassword'; with: ('New Password' translateFor: self session user).
						html textInput attributeAt: 'id' put: 'newPassword'; callback: [:value | searchValues at: 'new-pwd' put: value].
						html label attributeAt: 'for' put: 'newPassword2'; with: ('Repeat New Password' translateFor: self session user).
						html textInput attributeAt: 'id' put: 'newPassword2'; callback: [:value | searchValues at: 'repeat-new-pwd' put: value].
						html submitButton callback: [self changePassword]; with: ('Confirm' translateFor: self session user).
						informationComponent ifNotNil: [html render: informationComponent].
					].
				].
		].! !

!WAChangeUserPasswordComposite methodsFor: 'other' stamp: 'BrunoBB 12/03/2016 05:53'!
renderContentOn: html

	self renderChangePasswordOn: html.! !

SEWAFWebObjectComposite subclass: #WASetUserLanguage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMWebBasic'!

!WASetUserLanguage methodsFor: 'other' stamp: 'BrunoBB 03/15/2016 10:41'!
currentDictionaryName

	^searchValues at: 'selected-language' ifAbsent: ['']! !

!WASetUserLanguage methodsFor: 'other' stamp: 'brunobb 07/27/2017 06:10'!
gitbookUrl

	^self getGemStoneServerConfiguration baseUrlDocumentation, 'fo_set_language.html'! !

!WASetUserLanguage methodsFor: 'other' stamp: 'BrunoBB 03/15/2016 10:41'!
renderContentOn: html

	html div id: 'internationalization'; class: 'centered-unique-form'; with: [
		html form with: [ 
			html fieldSet with: [
			html legend with: [html strong: ('Languages' translateFor: self session user)].
					html label attributeAt: 'for' put: 'language'; with: ('Select Language' translateFor: self session user).
					html select 
						attributeAt: 'id' put: 'language';
						class: '';
						list: (#(''), self getInternationalization currentDictionaries);
						callback: [:value | searchValues at: 'selected-language' put: value];
						selected: self session user currentLanguage.
					html submitButton 
						callback: [self setLanguage]; 
						with: ('Set Language' translateFor: self session user).
				].
		].
	].! !

!WASetUserLanguage methodsFor: 'other' stamp: 'BrunoBB 03/15/2016 10:41'!
setLanguage

	self session user setLanguage: self currentDictionaryName! !
